<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- bootstrap link -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- link data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
    <title>Task 512.50</title>
</head>

<body>
    <div class="container">
        <div class="text-center">
            <h3>DANH SÁCH LIÊN HỆ</h3>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-contact"><i class="fa fa-plus"></i>&nbsp; Thêm contact</button>
        </div>
        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="contact-table">
                <thead class="bg-info">
                    <tr>
                        <th>STT</th>
                        <th>Email</th>
                        <th>Action</th>
                    </tr>
                </thead>
            </table>
        </div>
        <!-- Add contact modal -->
        <div>
            <div id="add-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Add new contact</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-add-contact-email">Email</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-add-contact-email" name="ContactEmail"
                                            placeholder="Email..." class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-create-cancel"
                                data-dismiss="modal">Cancel</button>
                            <button class="btn btn-success" id="btn-confirm-add-contact">Insert contact</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Add contact modal -->
        <div>
            <div id="update-contact-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Update contact</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="input-update-contact-email">Email</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-contact-email" name="contactEmail"
                                            placeholder="Email..." class="form-control">
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                            <button class="btn btn-success" id="btn-confirm-update-contact">Update contact</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Contact Delete Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa contact này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-contact">Confirm</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://localhost:8000/contacts/";
    const gTABLE_NAME_COL = ["stt", "email", "action"];
    var gContactId = "";
    var gStt = 0;
    var gContactObj = {
        email: ""
    }
    var gContactTable = $("#contact-table").DataTable({
        paging: false,
        columns: [
            { data: gTABLE_NAME_COL[0] },
            { data: gTABLE_NAME_COL[1] },
            { data: gTABLE_NAME_COL[2] }

        ],
        columnDefs: [

            {
                targets: 0,
                render: function () {
                    return gSTT++;
                }
            },
            {
                targets: 2,
                defaultContent: ` <img class="edit-contact" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                        <img class="delete-contact" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                        `
            }

        ]
    })

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //gán sự kiện cho nút Thêm contact

    $(document).on("click", "#btn-add-contact", function () {
        $("#add-contact-modal").modal("show");
    });

    //gán sự kiện cho nút Insert contact (trên modal):
    $("#add-contact-modal").on("click", "#btn-confirm-add-contact", function () {
        onBtnInsertContactClick(gContactObj)
    });

    //gán sự kiện cho nút Update contact
    $("#contact-table").on("click", ".edit-contact", function () {
        gContactId = onBtnUpdateContactClick(this)
        // updateUserByUserId(gUserId)
        showContactDataIntoModalUpdate(gContactObj)

    });

    //gán sự kiện cho nút Update contact (trên modal):
    $("#update-contact-modal").on("click", "#btn-confirm-update-contact", function () {
        onBtnConfirmUpdateContactClick(gContactObj);
    });

    //gán sự kiện cho nút delete contact trên table

    $("#contact-table").on("click", ".delete-contact", function () {
        gContactId = onBtnDeleteContactClick(this)
        $("#delete-confirm-modal").modal("show");

    });
    //gán sự kiện cho nút Delete user (trên modal):
    $("#delete-confirm-modal").on("click", "#btn-confirm-delete-contact", function () {
        onBtnConfirmDeleteContactClick()
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getContactList();
    }
    //hàm ấn nút Insert Contact (trên modal):
    function onBtnInsertContactClick(paramContactObj) {
        readDataContact(paramContactObj);
        var vDataValid = validateContactData(paramContactObj);
        if (vDataValid) {
            callApiToAddNewContact(paramContactObj)
        }
    }
    //hàm ấn nút update Contact trong table:
    function onBtnUpdateContactClick(paramBtnUpdate) {
        var vTableRow = $(paramBtnUpdate).parents("tr");
        var vDataTableRow = gContactTable.row(vTableRow);
        var vContactIdObj = vDataTableRow.data()._id;
        gContactObj = vDataTableRow.data()
        return vContactIdObj

    }

    //hàm ấn nút update Contact (trên modal): 
    function onBtnConfirmUpdateContactClick() {
        readDataUpdateContact(gContactObj);
        var vDataUpdateValid = validateDataUpdateContact(gContactObj);
        if (vDataUpdateValid) {
            callApiToUpdateContactById(gContactObj)
        }
    }
    //hàm ấn nút delete contact trên table:
    function onBtnDeleteContactClick(paramBtnDelete) {
        var vTableRow = $(paramBtnDelete).parents("tr");
        var vDataTableRow = gContactTable.row(vTableRow);
        var vContactIdObj = vDataTableRow.data()._id;
        return vContactIdObj
    }

    //hàm ấn nút update contact (trên modal): 
    function onBtnConfirmDeleteContactClick() {
        console.log("xoa xoa")
        callApiToDeleteContactById(gContactId)

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm lấy danh sách contact:
    function getContactList() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                loadContactListIntoTable(paramRes)
            },
            error: function (paramError) {
                console.log(paramError.responseText)
            }
        })
    };
    //hàm load contact vào table
    function loadContactListIntoTable(paramContactList) {
        gSTT = 1;
        gContactTable.clear();
        gContactTable.rows.add(paramContactList.data);
        gContactTable.draw();
    }

    //Các hàm xử lý thêm contact
    //hàm show user data into modal update:
    function showContactDataIntoModalUpdate(paramContactData) {
        $("#input-update-contact-email").val(paramContactData.email);
        $("#update-contact-modal").modal("show");
    }
    //hàm đọc dữ liệu contact nhập vào("trên modal"):
    function readDataContact(paramContactObj) {
        paramContactObj.email = $.trim($("#input-add-contact-email").val());
    }
    //hàm validate dữ liệu contact nhập vào("trên modal"):
    function validateContactData(paramContactObj) {
        if (paramContactObj.email == "") {
            alert("Please input email");
            return false;
        }
        return true
    }
    //hàm gọi API để thêm contact mới:
    function callApiToAddNewContact(paramContactObj) {
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramContactObj),
            success: function (paramRes) {
                handleInsertContactSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }
    //hàm handle khi add contact thành công:
    function handleInsertContactSuccess() {
        alert("Add contact successfully");
        resertInsertContactForm();
        $("#add-contact-modal").modal("hide");
        getContactList()
    }
    //hàm xóa trắng form insert contact:
    function resertInsertContactForm() {
        $("#input-add-contact-email").val("");

    }
    // Các hàm xử lý update contact
    //hàm đọc dữ liệu update contact nhập vào("trên modal"):
    function readDataUpdateContact(paramContactObj) {
        paramContactObj.email = $.trim($("#input-update-contact-email").val());

    }
    //hàm validate dữ liệu update contact nhập vào("trên modal"):
    function validateDataUpdateContact(paramContactObj) {
        if (paramContactObj.email == "") {
            alert("Please input email");
            return false;
        }

        return true
    }
    //hàm gọi API để update contact:
    function callApiToUpdateContactById(paramContactObj) {
        $.ajax({
            url: gBASE_URL + gContactId,
            type: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramContactObj),
            success: function (paramRes) {
                handleUpdateContactSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }

    //hàm handle khi update contact thành công:
    function handleUpdateContactSuccess() {
        alert("Update contact successfully");
        resertUpdateContactForm();
        $("#update-contact-modal").modal("hide");
        getContactList()
    }
    //hàm xóa trắng form insert contact:
    function resertUpdateContactForm() {
        $("#input-update-contact-email").val("");

    }

     //các hàm xử lý delete contact:
    //hàm gọi API để delete contact:
    function callApiToDeleteContactById(paramContactIdObj) {
        $.ajax({
            url: gBASE_URL + paramContactIdObj,
            type: "DELETE",
            success: function (paramRes) {
                handleDeleteContactSuccess()
            },
            error: function (paramErorr) {
                console.log(paramErorr.responseText)
            }
        });
    }
    //hàm handle khi delete user thành công:
    function handleDeleteContactSuccess() {
        alert("Delete contact successfully");
        $("#delete-confirm-modal").modal("hide");
        getContactList()
    }

</script>

</html>